﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="XFormSelect.ascx.cs" Inherits="UppsalaKommun.Insidan.epi.edit.XFormSelect" %>
<%@ Import Namespace="EPiServer.Core" %>
<%@ Import Namespace="EPiServer.Web.PageExtensions" %>

<script type="text/javascript">
//<![CDATA[
var KEYCODE_C = 67;

if(document.all)
{
    window.document.attachEvent('onkeydown', xFormKeyHandler);
    window.document.body.focus();
}
var folderDialogUrl = '<%=ResolveUrl("XFormFolderDialog.aspx")%>';

function xFormKeyHandler()
{
	var returnValue = true;	

	if (event.shiftKey && event.ctrlKey)
	{
		switch (event.keyCode)
		{
			case KEYCODE_C:
				var formId = document.getElementById('<%=SelectedFormID.ClientID%>').value;
				if (confirm("Copy xform id to clipboard?\n\n" + formId))
					clipboardData.setData("Text", formId);
				break;
		}
	}
	
	return returnValue;
}

function setxFormID(formID)
{
    document.getElementById('<%=SelectedFormID.ClientID%>').value =  formID;
}

function editXForm(action,sFormID)
{
    var editUrl = '<%=ResolveUrl("XFormEdit.aspx")%>?pageId=<%=Request["pageId"]%>&parentId=<%=Request["parentId"]%>&formid=';
	if(action=='edit')
	{
		 editUrl = editUrl + sFormID;		 
	}
	
	var index = document.getElementById('<%= FormFolders.ClientID %>').selectedIndex;
	editUrl = editUrl +"&selectedFormName=" + document.getElementById('<%= FormFolders.ClientID %>')[index].value;
	
	EPi.CreateDialog(editUrl, OnEditDialogCompleted, null, null, {width:900, height:800});
}

function OnEditDialogCompleted(formid, onCompleteArguments)
{
    if (formid != null)
    {
        document.getElementById("<%= SelectedFormID.ClientID %>").value = formid;
    }        
	document.getElementById("<%= HiddenPostBackButton.ClientID %>").click();
}

function clearValue()
{
    selectAndClose('');
}
function cancel()
{
    selectAndClose(null);
}
function selectAndClose(selectedForm)
{
	EPi.GetDialog().Close(selectedForm);
}

function LaunchNewFolderWindow()
{
	EPi.CreateDialog(folderDialogUrl + "?mode=create", FolderDialogClose, null, null, {width:350, height:40});
}

function LaunchRenameFolderWindow()
{
	var folderList = document.getElementById('<%= FormFolders.ClientID %>');
	var dialogArguments;
	var onCompleteArguments = dialogArguments = folderList.options[folderList.selectedIndex].text;
	
    EPi.CreateDialog(folderDialogUrl + "?mode=rename", FolderDialogClose, onCompleteArguments, dialogArguments, {width:350, height:40});
}

function FolderDialogClose(returnValue, onCompleteArguments)
{
    if (!returnValue)
    {
        return;
    }
    
    if (onCompleteArguments)
	{
	    document.getElementById('<%=RenameFolder.ClientID%>').value = onCompleteArguments;
    }
	document.getElementById('<%=NewFolderName.ClientID%>').value = returnValue;
	document.forms[0].submit();
}

function LaunchDeleteFolderWindow()
{
	var folderList = document.getElementById('<%= FormFolders.ClientID %>');
	var selectedFolder = folderList.options[folderList.selectedIndex].value;

	if (confirm('<%=Translate("/edit/editxform/folderdialog/deletequestion")%>'))
	{
		document.getElementById('<%=DeleteFolder.ClientID%>').value = selectedFolder;
		document.forms[0].submit();
	}
}
//]]>
</script>

<EPiServerScript:ScriptSettings runat="server" ConfirmMessage="<%$ Resources: EPiServer, edit.editxform.deletequestion  %>" ID="deleteCommon" />

<div style="margin: 0.5em; padding-bottom: 1em;">
    <div>
        
        <span style="float:right; margin-right: 1em;"><EPiServerUI:HelpButton Runat="server" /></span>
        <asp:Label ID="Label1" runat="server"><strong><episerver:translate ID="Translate1" runat="server" text="/edit/editxform/selectedfolder" /></strong></asp:Label>
        <asp:ListBox ID="FormFolders" runat="server" AutoPostBack="True" Rows="1" Width="150px" OnSelectedIndexChanged="FormFolders_SelectedIndexChanged" />
        &nbsp;&nbsp;
        <EPiServerUI:ToolButton SkinId="CreateFolder" Id="NewFolderButton" Tooltip="<%$ Resources: EPiServer, edit.editxform.createnewformfoldertooltip %>" runat="server" GeneratesPostBack="False" />
        <EPiServerUI:ToolButton SkinId="RenameFolder" Id="RenameFolderButton" Tooltip="<%$ Resources: EPiServer, edit.editxform.renameformfoldertooltip %>" runat="server" GeneratesPostBack="False" />
        <EPiServerUI:ToolButton SkinId="DeleteFolder" Id="DeleteFolderButton" Tooltip="<%$ Resources: EPiServer, edit.editxform.deleteformfoldertooltip %>" runat="server" GeneratesPostBack="False" />
        <EPiServerScript:ScriptEvent EventTargetId="newFolderButton" EventType="click" EventHandler="LaunchNewFolderWindow" runat="server" />
        <EPiServerScript:ScriptEvent EventTargetId="renameFolderButton" EventType="click" EventHandler="LaunchRenameFolderWindow" runat="server" />
        <EPiServerScript:ScriptEvent EventTargetId="deleteFolderButton" EventType="click" EventHandler="LaunchDeleteFolderWindow" runat="server" />
        &nbsp;&nbsp;&nbsp;&nbsp;
         <asp:Label ID="Label2" runat="server"><strong><episerver:translate ID="Translate2" runat="server" text="/edit/editxform/listmyformonly" /></strong></asp:Label>
         <asp:CheckBox ID="chkListMyFormsOnly" runat="server"  OnCheckedChanged="ListMyFormsOnly_Changed" AutoPostBack="true" />
         
    </div>
                
    <asp:DataGrid ID="GridAvailableXForms" 
        AllowSorting="True" 
        AutoGenerateColumns="False" BorderWidth="0" 
        Width="100%" Runat="server" 
        AllowPaging="true" PageSize="10"      
        HeaderStyle-ForeColor="white"  
        PagerStyle-CssClass="epitableheading"
        PagerStyle-ForeColor="White" 
        ShowFooter="False"  
        OnSortCommand="Sort_Click"
        OnPageIndexChanged="DoGridPaging"
        OnItemCommand="GridAvailableXForms_ItemCommand"
        UseAccessibleHeader="true"
        >
        <ItemStyle CssClass="FM-ItemRow"/>
        <Columns>
           <asp:BoundColumn SortExpression="FormName" HeaderText="<%$ Resources: EPiServer, edit/editxform/formname %>" DataField="FormName" >		                		                
           </asp:BoundColumn>
           <asp:BoundColumn SortExpression="Folder" HeaderText="<%$ Resources: EPiServer, edit/editxform/folder %>" DataField="Folder">		                		                
           </asp:BoundColumn>
           <asp:BoundColumn SortExpression="" HeaderText="<%$ Resources: EPiServer, edit/editxform/usedonpages %>" DataField="UsedonPages">		                		                
           </asp:BoundColumn>
           <asp:BoundColumn SortExpression="Created" HeaderText="<%$ Resources: EPiServer, edit/editxform/gridheadingcreated%>" DataField="Created">		                
           </asp:BoundColumn>
           <asp:BoundColumn SortExpression="CreatedBy" HeaderText="<%$ Resources: EPiServer, edit/editxform/gridheadingcreatedby %>" DataField="CreatedBy">		                		                
           </asp:BoundColumn>
           <asp:BoundColumn SortExpression="Changed" HeaderText="<%$ Resources: EPiServer, edit/editxform/gridheadingchanged %>" DataField="Changed">		                		                
           </asp:BoundColumn>
           <asp:BoundColumn SortExpression="ChangedBy" HeaderText="<%$ Resources: EPiServer, edit/editxform/gridheadingchangedby %>" DataField="ChangedBy">		                		                
           </asp:BoundColumn>	               
           <asp:TemplateColumn HeaderText="<%$ Resources: EPiServer, button.edit %>" ItemStyle-HorizontalAlign="left">
                <ItemTemplate>
                    <EPiServerUI:ToolButton SkinID="Edit" Id="EditExistingFormButton" Enabled='true' runat="server" 
                    ToolTip="<%$ Resources: EPiServer, button.edit %>" 
                    OnClientClick=<%# "editXForm('edit','"+ DataBinder.Eval(Container.DataItem,"xformID") + "' )" %>
                    GeneratesPostBack="False" />
                </ItemTemplate>                
            </asp:TemplateColumn>
            <asp:TemplateColumn HeaderText="<%$ Resources: EPiServer, button.delete %>" ItemStyle-HorizontalAlign="left">
                <ItemTemplate>
                   <EPiServerUI:ToolButton ID="DeleteButton" CommandName="Delete" SkinID="Delete" 
                   EnableClientConfirm="true" 
                   ToolTip="<%$ Resources: EPiServer, button.delete %>" 
                   OnClientClick=<%# "setxFormID('"+ DataBinder.Eval(Container.DataItem,"xformID") + "')" %> 
                   Enabled=<%# DataBinder.Eval(Container.DataItem, "ButtonStatus") %>
                   runat="server" />
                    <EPiServerScript:ScriptSettings runat="server" TargetControlID="DeleteButton" CommonSettingsControlID="deleteCommon" />                    
                </ItemTemplate>
            </asp:TemplateColumn>
            <asp:TemplateColumn HeaderText="<%$ Resources: EPiServer, button.select %>" ItemStyle-HorizontalAlign="left">
                <ItemTemplate>
                    <EPiServerUI:ToolButton CommandName="Select" runat="server" SkinID="Check" Enabled="true" 
                    CausesValidation="false"
                    ToolTip="<%$ Resources: EPiServer, button.select %>" />
                </ItemTemplate>
            </asp:TemplateColumn>
        </Columns> 	          
        <PagerStyle Mode="NumericPages" Visible="true" />     
     </asp:DataGrid>                   

    <div style="overflow:hidden; margin-top: 1em;">
        <div style="float:left;">
            <EPiServerUI:ToolButton SkinID="Add" Id="CreatexFormButton" Text="<%$ Resources: EPiServer, button.create %>" runat="server" OnClientClick="editXForm('create','' )" GeneratesPostBack="False" />
        </div>
        <div style="float:right; text-align:right;">
            
            <EPiServerUI:ToolButton SkinID="Save" Id="UseButton" Text="<%$ Resources: EPiServer, edit.editxform.useformbutton %>" runat="server" OnClick="UseForm_Click" />
            <EPiServerUI:ToolButton SkinID="Delete" Id="ClearButton" Text="<%$ Resources: EPiServer, edit.editxform.noformbutton %>" runat="server" OnClientClick="clearValue();" GeneratesPostBack="False" />
            <EPiServerUI:ToolButton SkinID="Cancel" Id="CancelButton" Text="<%$ Resources: EPiServer, button.cancel %>" runat="server" OnClientClick="cancel();" GeneratesPostBack="False" />            
        </div>
    </div>
</div>
<div style="padding-left: 7px;">
    <asp:ValidationSummary ID="ValidationSummary" runat="server" CssClass="EP-validationSummary"
        ForeColor="Black" />
</div>
<asp:Button style="display:none;" Id="HiddenPostBackButton" OnClick="HiddenPostBackButton_Click" runat="server" />
<asp:Label ID="statusLabel" runat="server" Text=""></asp:Label>
<input type="hidden" runat="Server" id="SelectedFormID" />
<input type="hidden" runat="Server" id="RenameFolder" />
<input type="hidden" runat="Server" id="NewFolderName" />
<input type="hidden" runat="Server" id="DeleteFolder" />