﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EPiServer;
using System.Data;
using EPiServer.XForms;
using EPiServer.UI.WebControls;
using EPiServer.ClientScript.WebControls;
using System.Web.UI.HtmlControls;
using EPiServer.Web.WebControls;
using EPiServer.Core;
using System.Collections;
using EPiServer.Util;
using EPiServer.ClientScript.Events;
using EPiServer.ClientScript;
using EPiServer.BaseLibrary;
using log4net;
using System.Diagnostics;
using System.Text;
using UppsalaKommun.CommonLibrary.Web.Managers;

namespace UppsalaKommun.Insidan.epi.edit
{
     public partial class XFormSelect : UserControlBase
    {
    // Fields
    private bool _deleteFolderEnabled;
    private DataSet _ds;
    private string _formId;
    private bool _newFolderEnabled;
    private bool _renameFolderEnabled;
    private XForm _xForm;
    protected ToolButton CancelButton;
    protected CheckBox chkListMyFormsOnly;
    protected ToolButton ClearButton;
    protected ToolButton CreatexFormButton;
    protected ScriptSettings deleteCommon;
    protected HtmlInputHidden DeleteFolder;
    protected ToolButton DeleteFolderButton;
    protected ListBox FormFolders;
    protected DataGrid GridAvailableXForms;
    protected Button HiddenPostBackButton;
    protected ToolButton NewFolderButton;
    protected HtmlInputHidden NewFolderName;
    protected HtmlInputHidden RenameFolder;
    protected ToolButton RenameFolderButton;
    protected HtmlInputHidden SelectedFormID;
    protected Translate Translate1;
    protected Translate Translate2;
    protected ToolButton UseButton;
    private XFormManager xformManager = new XFormManager();
    
    protected ValidationSummary ValidationSummary;
    private ILog Logger = log4net.LogManager.GetLogger("XFormSelect");
    // Methods
    private int CalculateSelectedIndex(int selectedIndex)
    {
        int pageSize = this.GridAvailableXForms.PageSize;
        int currentPageIndex = this.GridAvailableXForms.CurrentPageIndex;
        if (selectedIndex >= 0)
        {
            int num3 = selectedIndex - (currentPageIndex * pageSize);
            if (((pageSize * currentPageIndex) <= selectedIndex) && ((pageSize * (currentPageIndex + 1)) > selectedIndex))
            {
                return num3;
            }
        }
        return -1;
    }

    internal static string DefaultSelectedFormFolder(string pageIdString, string parentIdString)
    {
        PageReference pageLink = PageReference.Parse(pageIdString);
        if (pageLink == PageReference.EmptyReference)
        {
            pageLink = PageReference.Parse(parentIdString);
        }
        if (pageLink != PageReference.EmptyReference)
        {
            PageData page = DataFactory.Instance.GetPage(pageLink);
            if ((page["DefaultFormFolder"] != null) && (page["DefaultFormFolder"].ToString().Length > 0))
            {
                string strB = page["DefaultFormFolder"].ToString();
                foreach (XFormFolder folder in XFormFolder.GetFolders())
                {
                    if (string.Compare(folder.Name, strB, false) == 0)
                    {
                        return folder.SubPath;
                    }
                }
            }
        }
        return "/";
    }

    protected void DoGridPaging(object sender, DataGridPageChangedEventArgs e)
    {
        this.GridAvailableXForms.CurrentPageIndex = e.NewPageIndex;
        this.LoadConditionalGrid();
    }

    protected void FormFolders_SelectedIndexChanged(object sender, EventArgs e)
    {
        ListBox box = (ListBox) sender;
        this.FormFolder = box.SelectedValue;
        this.GridAvailableXForms.CurrentPageIndex = 0;
        this.LoadForms(this.FormFolder,chkListMyFormsOnly.Checked);
        this.SetFormFolderToolsAvailability();
    }

    private static ListBox GetSortedList(ListBox list)
    {
        SortedList list2 = new SortedList();
        foreach (ListItem item in list.Items)
        {
            list2.Add(item.Value.ToString(), item.Text.ToString());
        }
        list.Items.Clear();
        foreach (DictionaryEntry entry in list2)
        {
            ListItem item2 = new ListItem();
            item2.Text = entry.Value.ToString();
            item2.Value = entry.Key.ToString();
            list.Items.Add(item2);
        }
        return list;
    }

    private string GetxFormUsedonPages(string formId)
    {
        return xformManager.GetxFormUsedonPages(formId);
        //StringBuilder str = new StringBuilder();
        //PageDataCollection datas = XFormHelper.ListFormReferences(formId);
        //for (int i = 0; i < datas.Count; i++)
        //{
        //    str.Append(string.Format("{0}[{1}]<br />",datas[i].PageName.ToString(),datas[i].PageLink.ToString()));
        //}
        //if (str.Length > 0)
        //{
        //    str.Insert(0, "<strong>");
        //    str.Append("</strong>");
        //}
        //return str.ToString();
    }

    protected void GridAvailableXForms_ItemCommand(object source, DataGridCommandEventArgs e)
    {
        if (e.CommandName == "Select")
        {
            this.SelectedRowIndex = e.Item.DataSetIndex;
            this._ds = (DataSet) base.Cache["xFormds"];
            DataRowView view = this._ds.Tables[0].DefaultView[this.SelectedRowIndex];
            this.SelectedFormID.Value = view["xformID"].ToString();
            this.SelectedFormName = view["FormName"].ToString();
            this.SelectedFormLastSortValue = view[this.LastSort].ToString();
            this.UseButton.Enabled = true;
        }
        else if ((e.CommandName == "Delete") && (this.XForm != null))
        {
            if ((this.GridAvailableXForms.Items.Count % this.GridAvailableXForms.PageSize) == 1)
            {
                this.GridAvailableXForms.CurrentPageIndex = Math.Max(0, this.GridAvailableXForms.PageCount - 2);
            }
            this.XForm.Delete();
            xformManager.DeleteForm(this.XForm); //Update cache
            //Todo update cache
            this.LoadForms(this.FormFolder, this.chkListMyFormsOnly.Checked);
            this.SetFormFolderToolsAvailability();
        }
    }

    protected void HiddenPostBackButton_Click(object sender, EventArgs e)
    {
        this.FormId = this.SelectedFormID.Value;
        this.LoadForms(this.FormFolder, this.chkListMyFormsOnly.Checked, true);
    }

    private bool isGridButtonEnabled(string usedonPages)
    {
        bool flag = false;
        if (usedonPages.Trim().Length == 0)
        {
            flag = true;
        }
        return flag;
    }

    protected void ListMyFormsOnly_Changed(object sender, EventArgs e)
    {
        this.GridAvailableXForms.CurrentPageIndex = 0;
        this.LoadConditionalGrid();
    }

    private void LoadConditionalGrid()
    {
        this.LoadForms(this.FormFolders.SelectedValue, this.chkListMyFormsOnly.Checked);
    }

    private void LoadFormFolders()
    {
        this.FormFolders.Items.Clear();
        foreach (XFormFolder folder in XFormFolder.GetFolders())
        {
            this.FormFolders.Items.Add(new ListItem(folder.Name, folder.SubPath));
        }
        this.FormFolders = GetSortedList(this.FormFolders);
        this.FormFolders.Items.Add(new ListItem(base.TranslateForScript("/edit/editxform/allforms"), "/"));
    }

    private void LoadForms(string folder)
    {
        this.LoadForms(folder, false);
    }

    private void LoadForms(string folder, bool iListMyFormOnly)
    {
        this.LoadForms(folder, iListMyFormOnly, false);
    }
    
    private void LoadForms(string folder, bool iListMyFormOnly, bool loadSelectedFormPageIndex)
    {
        string str = HttpContext.Current.User.Identity.Name.ToString();
        string usedonPages = "";
        new DataView();
        this._ds = new DataSet();
        DataTable table = new DataTable();
        table.Columns.Add("FormName", typeof(string));
        table.Columns.Add("Folder", typeof(string));
        table.Columns.Add("UsedonPages", typeof(string));
        table.Columns.Add("Created", typeof(string));
        table.Columns.Add("CreatedBy", typeof(string));
        table.Columns.Add("Changed", typeof(string));
        table.Columns.Add("ChangedBy", typeof(string));
        table.Columns.Add("xformID", typeof(string));
        table.Columns.Add("ButtonStatus", typeof(bool));
       
        //IList<XForm> list = folder.Equals("/") ? XFormFolder.GetForms() : XFormFolder.GetForms(folder);
        //Hämta xforms från cache om det finns via xformmanager. 
        IEnumerable<XForm> list = folder.Equals("/") ? xformManager.GetForms() : xformManager.GetForms(folder);
        DataRow row = null;
        DataRow row2 = null;
        Logger.Info("Creating XForms dataset.Starting watch");
        Stopwatch watch = new Stopwatch();
        watch.Start();
        foreach (XForm form in list)
        {
            usedonPages = this.GetxFormUsedonPages(form.Id.ToString());
            object[] values = new object[] { form.FormName.ToString(), form.Folder.Name.ToString(), usedonPages, form.Created.ToString(), form.CreatedBy.ToString(), form.Changed.ToString(), form.ChangedBy.ToString(), form.Id.ToString(), this.isGridButtonEnabled(usedonPages) };
            if (iListMyFormOnly)
            {
                if (form.CreatedBy == str)
                {
                    row2 = table.Rows.Add(values);
                }
            }
            else
            {
                row2 = table.Rows.Add(values);
            }
            if (form.Id.ToString() == this.FormId)
            {
                row = row2;
                this.FormId = null;
            }
        }
        watch.Stop();
        Logger.Info(string.Format("Created XForms dataset. Time(ms):{0}", watch.ElapsedMilliseconds));
        this._ds.Tables.Add(table);
        if (this._ds.Tables[0].Rows.Count == 0)
        {
            this.GridAvailableXForms.Visible = false;
            this.GridAvailableXForms.CurrentPageIndex = 0;
            this.GridAvailableXForms.SelectedIndex = -1;
            this.UnSelectXForm();
        }
        else
        {
            if (this.LastSort == null)
            {
                this.LastSort = this._ds.Tables[0].Columns[0].Caption;
                this.LastSortDirection = "ASC";
            }
            this._ds.Tables[0].DefaultView.Sort = this.LastSort + " " + this.LastSortDirection + ", xformID";
            this.GridAvailableXForms.Visible = true;
            base.Cache["xFormds"] = this._ds;
            if (row != null)
            {
                this.SelectedFormName = row["FormName"].ToString();
                this.SelectedFormLastSortValue = row[this.LastSort].ToString();
            }
            if (this.SelectedFormLastSortValue != null)
            {
                this.SelectedRowIndex = this._ds.Tables[0].DefaultView.Find(new object[] { this.SelectedFormLastSortValue, this.SelectedFormID.Value });
                if (this.SelectedRowIndex == -1)
                {
                    this.SelectedFormName = null;
                    this.SelectedFormLastSortValue = null;
                    this.SelectedFormID.Value = "";
                }
            }
            if (loadSelectedFormPageIndex)
            {
                this.GridAvailableXForms.CurrentPageIndex = this.SelectedRowIndex / this.GridAvailableXForms.PageSize;
            }
            this.GridAvailableXForms.SelectedIndex = this.CalculateSelectedIndex(this.SelectedRowIndex);
            this.GridAvailableXForms.DataSource = this._ds.Tables[0].DefaultView;
            this.GridAvailableXForms.DataBind();
        }
        this.UseButton.Enabled = this.SelectedFormName != null;
    }

    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);
        base.RegisterClientScriptFile(UriSupport.ResolveUrlFromUtilBySettings("javascript/common.js"));
        if (!base.IsPostBack)
        {
            XForm form;
            this.FormId = this.SelectedFormID.Value = base.Request.QueryString["form"];
            this.LoadFormFolders();
            if (((this.FormId != null) && (this.FormId.Length > 0)) && ((form = XForm.CreateInstance(new Guid(this.FormId))) != null))
            {
                this.FormFolder = form.Folder.SubPath;
                this.FormFolders.SelectedValue = this.FormFolder;
            }
            else
            {
                this.FormFolder = DefaultSelectedFormFolder(base.Request["pageId"], base.Request["parentId"]);
                this.FormFolders.SelectedValue = this.FormFolder;
            }
            this.LoadForms(this.FormFolder, false, true);
        }
        else
        {
            this.UpdateFormFolders();
        }
        this.SetFormFolderToolsAvailability();
    }

    private void SetFormFolderToolsAvailability()
    {
        this.NewFolderEnabled = true;
        if (string.Compare(this.FormFolders.SelectedValue, "/", true) != 0)
        {
            this.RenameFolderEnabled = true;
            if (((this._ds != null) && (this._ds.Tables[0].Rows.Count == 0)) && !this.chkListMyFormsOnly.Checked)
            {
                this.DeleteFolderEnabled = true;
            }
            else
            {
                this.DeleteFolderEnabled = false;
            }
        }
        else
        {
            this.RenameFolderEnabled = false;
            this.DeleteFolderEnabled = false;
        }
        this.NewFolderButton.Enabled = this.NewFolderEnabled;
        this.RenameFolderButton.Enabled = this.RenameFolderEnabled;
        this.DeleteFolderButton.Enabled = this.DeleteFolderEnabled;
    }

    protected void Sort_Click(object sender, DataGridSortCommandEventArgs e)
    {
        if (((this.LastSort != null) && (this.LastSort == e.SortExpression)) && (this.LastSortDirection == "ASC"))
        {
            this.LastSortDirection = "DESC";
        }
        else
        {
            this.LastSortDirection = "ASC";
        }
        this.LastSort = e.SortExpression;
        this._ds = (DataSet) base.Cache["xFormds"];
        this._ds.Tables[0].DefaultView.Sort = this.LastSort + " " + this.LastSortDirection + ", xformID";
        this.SelectedRowIndex = this._ds.Tables[0].DefaultView.Find(new object[] { this.SelectedFormLastSortValue, this.SelectedFormID.Value });
        this.GridAvailableXForms.SelectedIndex = this.CalculateSelectedIndex(this.SelectedRowIndex);
        this.GridAvailableXForms.DataSource = this._ds.Tables[0].DefaultView;
        this.GridAvailableXForms.DataBind();
    }

    protected void UnSelectXForm()
    {
        string str;
        this.SelectedFormID.Value = "";
        this.GridAvailableXForms.SelectedIndex = this.SelectedRowIndex = -1;
        this.SelectedFormLastSortValue = (string) (str = null);
        this.SelectedFormName = str;
        this.UseButton.Enabled = false;
    }

    private void UpdateFormFolders()
    {
        if (this.DeleteFolder.Value.Length > 0)
        {
            XFormFolder.Delete(this.DeleteFolder.Value);
            this.LoadFormFolders();
            this.FormFolder = DefaultSelectedFormFolder(base.Request["pageId"], base.Request["parentId"]);
            this.FormFolders.SelectedValue = this.FormFolder;
            this.DeleteFolder.Value = "";
            this.LoadForms(this.FormFolder);
        }
        else if ((this.RenameFolder.Value.Length > 0) && (this.NewFolderName.Value.Length > 0))
        {
            if (!string.Equals(this.RenameFolder.Value, this.NewFolderName.Value, StringComparison.InvariantCultureIgnoreCase))
            {
                XFormFolder folder = XFormFolder.Create(this.RenameFolder.Value);
                try
                {
                    folder.Rename(this.NewFolderName.Value);
                    this.LoadFormFolders();
                    this.FormFolder = "/" + this.NewFolderName.Value;
                    this.FormFolders.SelectedValue = this.FormFolder;
                }
                catch (XFormException exception)
                {
                    this.Page.Validators.Add(new StaticValidator(exception.Message));
                }
            }
            this.RenameFolder.Value = "";
            this.NewFolderName.Value = "";
        }
        else if (this.NewFolderName.Value.Length > 0)
        {
            XFormFolder.Create(this.NewFolderName.Value);
            this.LoadFormFolders();
            this.FormFolder = "/" + this.NewFolderName.Value;
            this.FormFolders.SelectedValue = this.FormFolder;
            this.NewFolderName.Value = "";
            this.LoadForms(this.FormFolder);
        }
    }

    protected void UseForm_Click(object sender, EventArgs e)
    {
        string script = "\r\n            function CloseAfterPostback(e) {\r\n                EPi.GetDialog().Close( {id:'" + this.SelectedFormID.Value + "', name: '" + this.SelectedFormName + "'} ); }";
        this.Page.ClientScript.RegisterClientScriptBlock(base.GetType(), "closeAfterPostback", script, true);
        
        EPiServer.ClientScript.ScriptManager.Current.AddEventListener(this.Page, new CustomEvent(EventType.Load, "CloseAfterPostback"));
    }

    // Properties
    protected bool DeleteFolderEnabled
    {
        get
        {
            return this._deleteFolderEnabled;
        }
        set
        {
            this._deleteFolderEnabled = value;
        }
    }

    private string FormFolder
    {
        get
        {
            return (string) this.ViewState["FormFolder"];
        }
        set
        {
            this.ViewState["FormFolder"] = value;
        }
    }

    public string FormId
    {
        get
        {
            return this._formId;
        }
        set
        {
            if ((this._formId == null) || !this._formId.Equals(value))
            {
                this._xForm = null;
            }
            this._formId = value;
        }
    }

    private string LastSort
    {
        get
        {
            return (this.ViewState["LastSort"] as string);
        }
        set
        {
            this.ViewState["LastSort"] = value;
        }
    }

    private string LastSortDirection
    {
        get
        {
            return (this.ViewState["LastSortDirection"] as string);
        }
        set
        {
            this.ViewState["LastSortDirection"] = value;
        }
    }

    protected bool NewFolderEnabled
    {
        get
        {
            return this._newFolderEnabled;
        }
        set
        {
            this._newFolderEnabled = value;
        }
    }

    protected bool RenameFolderEnabled
    {
        get
        {
            return this._renameFolderEnabled;
        }
        set
        {
            this._renameFolderEnabled = value;
        }
    }

    private string SelectedFormLastSortValue
    {
        get
        {
            return (string) this.ViewState["SelectedFormLastSortValue"];
        }
        set
        {
            this.ViewState["SelectedFormLastSortValue"] = value;
        }
    }

    private string SelectedFormName
    {
        get
        {
            return (string) this.ViewState["SelectedFormName"];
        }
        set
        {
            this.ViewState["SelectedFormName"] = value;
        }
    }

    private int SelectedRowIndex
    {
        get
        {
            if (this.ViewState["SelectedRowIndex"] == null)
            {
                this.ViewState["SelectedRowIndex"] = -1;
            }
            return (int) this.ViewState["SelectedRowIndex"];
        }
        set
        {
            this.ViewState["SelectedRowIndex"] = value;
        }
    }

    public XForm XForm
    {
        get
        {
            if (this._xForm == null)
            {
                try
                {
                    this._xForm = XForm.CreateInstance(new Guid(this.SelectedFormID.Value));
                }
                catch (ObjectStoreException)
                {
                    this._xForm = null;
                }
                catch (Exception)
                {
                    this._xForm = null;
                }
            }
            return this._xForm;
        }
        set
        {
            this._xForm = value;
        }
    }

    }
}